// AXCAC01.h : main header file for the AXCAC01 application
//

#if !defined(AFX_AXCAC01_H__F26E2459_A7F1_4AFA_AF57_EDB8822F5D68__INCLUDED_)
#define AFX_AXCAC01_H__F26E2459_A7F1_4AFA_AF57_EDB8822F5D68__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

#define		AXC_AC_CF				0
#define		AXC_AD_CF				1
#define		AXC_DA_CF				2

#define		AD_MAX_DATA				16384
#define		AXC_RESPONSE_LENGTH		2

#define		AD_VAL_MAX				2.450
#define		AD_VAL_MAX_PA			2.430
#define		AD_VAL_MIN				0.000

#define		AD_CLOCK_INTERNAL		0
#define		AD_CLOCK_EXTERNAL		1

#define		AD_CLK_SRC1				0		// 1.02
#define		AD_CLK_SRC2				1		// 2.04
#define		AD_CLK_SRC3				2		// 5.10

#define		AD_CLK_BASE_1			0		// x 1
#define		AD_CLK_BASE_10			1		// x 10
#define		AD_CLK_BASE_100			2		// x 100

#define		AD_STS_WAIT_TG			0
#define		AD_STS_WAIT_TG			0

//	m_nADSetting(CAXCAC01Doc)
#define		AD_SAMP_SINGLE			0
#define		AD_SAMP_DOUBLE			1

//	m_nADSampling(CAXCAC01Doc)
#define		AD_SAMP_1_02			0
#define		AD_SAMP_2_04			1
#define		AD_SAMP_5_1				2
#define		AD_SAMP_10_2			3
#define		AD_SAMP_20_4			4
#define		AD_SAMP_51				5
#define		AD_SAMP_102				6
#define		AD_SAMP_204				7
#define		AD_SAMP_510				8

//	m_nADSamplingSet(CAXCAC01Doc)
#define		AD_SAMP_UM				0
#define		AD_SAMP_MM				1

//	m_nADDataNum(CAXCAC01Doc)
#define		AD_DATA_1024			0
#define		AD_DATA_2048			1
#define		AD_DATA_4096			2
#define		AD_DATA_8192			3
#define		AD_DATA_16384_0			4
#define		AD_DATA_16384_1			5

//	m_nTrig(CAXCAC01Doc)
#define		AD_TRG_NONE				0
#define		AD_TRG_EXT_U			1
#define		AD_TRG_EXT_D			2
#define		AD_TRG_CP_U				3
#define		AD_TRG_CP_D				4
#define		AD_TRG_PB_U				5
#define		AD_TRG_PB_D				6

// m_nDAValueSel(CAXCAC01Doc)
#define		AXC_DA_1MV				0
#define		AXC_DA_10MV				1
#define		AXC_DA_100MV			2
#define		AXC_DA_1V				3

#define		DA_VAL_MAX				2.430
#define		DA_VAL_MIN				0.000

// m_nSetPortA,B,C,D(CAXCAC01Doc)
#define		AXC_IO_IN				0		// ߰ē
#define		AXC_IO_OUT_O			1		// ڲݏo
#define		AXC_IO_OUT_P			2		// vbVvo
#define		AXC_IO_IN_AD			3		// |[gAD

#define		AXC_PORTA				0
#define		AXC_PORTB				1
#define		AXC_PORTC				2
#define		AXC_PORTD				3

#define		AXC_LOW					0
#define		AXC_HIGH				1

#define		BUTTON_TEXT_ON_COLOR	RGB(255,255,0)
#define		BUTTON_TEXT_OFF_COLOR	RGB(255,255,255)

#define		BACKGROUND_COLOR		RGB(230,230,230)	// 2004/03/18	224->230
#define		SELECT_MENU_COLOR		RGB(0,0,255)
#define		PEN1_COLOR				RGB(128,128,128)
#define		PEN2_COLOR				RGB(80,80,80)
#define		AD_FACE_COLOR			RGB(0,240,0)
#define		AD_TITLE_COLOR			RGB(255,255,255)
#define		AD_BK_COLOR				RGB(0,0,0)
#define		GRAPH_BK_COLOR			RGB(0,0,0)
#define		GRAPH_LINE_COLOR		RGB(80,240,80)
#define		GRAPH_COLOR				RGB(0,255,0)


// define Windows Position
#define		MENU_HEIGHT				26

#define		MAIN_BAR_HEIGHT			28
#define		MAIN_BAR_Y1				0
#define		MAIN_BAR_Y2				78
#define		MAIN_SEPARATOR			200

#define		AD_BAR_HEIGHT			28
#define		AD_BAR_Y1				0
#define		AD_SINGLE_WIDTH			100
#define		AD_SINGLE_HIGHT			40
#define		AD_SINGLE_TITLE_H		12
#define		AD_GRAPH_TITLE_H		17
#define		AD_GRAPH_WIDTH			AD_SINGLE_WIDTH*2
#define		AD_GRAPH_LABEL_X		1
#define		AD_GRAPH_LABEL_W		18
#define		AD_GRAPH_LABEL_H		9
#define		AD_BTN_WIDTH			25
#define		AD_BTN_HIGHT			25
#define		AD_SETBTN_X				212
#define		AD_SETBTN_Y				1
#define		AD_GOBTN_X				AD_SETBTN_X-AD_BTN_WIDTH-2
#define		AD_GOBTN_Y				AD_SETBTN_Y
#define		AD_SINGLEBTN_X			AD_SETBTN_X

#define		ADSET_BAR_HEIGHT		28
#define		ADSET_BAR_Y1			0
#define		ADSET_BAR_Y2			82
#define		ADSET_BAR_Y3			255
#define		ADSET_IN1_X				29
#define		ADSET_IN2_X				1
#define		ADSET_IN3_X				21
#define		ADSET_IN4_X				2
#define		ADSET_IN1_Y				130
#define		ADSET_IN2_Y				160
#define		ADSET_IN3_Y				190
#define		ADSET_IN4_Y				220
#define		ADSET_COMBO_X1			91
#define		ADSET_COMBO_X2			166

#define		DA_BAR_HEIGHT			28
#define		DA_BAR_Y1				0
#define		DA_BAR_Y2				82
#define		DA_BAR_Y3				260
#define		DA_STARTBTN_X			212
#define		DA_STARTBTN_Y			DA_BAR_Y2 + 1
#define		DA_STARTBTN_WIDTH		25
#define		DA_STARTBTN_HIGHT		25
#define		DA_VALUE_X				10
#define		DA_VALUE_Y				204
#define		DA_VALUE_WIDTH			100
#define		DA_VALUE_HIGHT			40
#define		DA_UPBTN_X				DA_VALUE_X+DA_VALUE_WIDTH
#define		DA_UPBTN_Y				DA_VALUE_Y
#define		DA_DOWNBTN_X			DA_UPBTN_X
#define		DA_DOWNBTN_Y			DA_UPBTN_Y+DA_UPDWNBTN_HIGHT
#define		DA_UPDWNBTN_WIDTH		20
#define		DA_UPDWNBTN_HIGHT		20

#define		GPIO_BAR_HEIGHT			28
#define		GPIO_BAR_Y1				0
#define		GPIO_BAR_Y2				30
#define		GPIO_BAR_Y3				140
#define		GPIO_BAR_Y4				GPIO_BAR_Y3+(GPIO_BAR_Y3-GPIO_BAR_Y2)
#define		GPIO_SETBTN_X			212
#define		GPIO_SETBTN_Y			1
#define		GPIO_STARTBTN_X			94
#define		GPIO_STARTBTN_Y			GPIO_BAR_Y2 + 1
#define		GPIO_STARTBTN_WIDTH		25
#define		GPIO_STARTBTN_HIGHT		25
#define		GPIO_BTN_X1				48
#define		GPIO_BTN_Y1				GPIO_BAR_Y2 + GPIO_BAR_HEIGHT + 18
#define		GPIO_BTN_X2				168
#define		GPIO_BTN_Y2				GPIO_BAR_Y3 + GPIO_BAR_HEIGHT + 18
#define		GPIO_STATIC_X1			10
#define		GPIO_STATIC_Y1			GPIO_BAR_Y2 + GPIO_BAR_HEIGHT + 22
#define		GPIO_BTN_WIDTH			32
#define		GPIO_BTN_HEIGHT			52
#define		GPIO_STATIC_WIDTH		100
#define		GPIO_STATIC_HEIGHT		40

#define		GPIOSET_BAR_HEIGHT		28
#define		GPIOSET_BAR_Y1			0
#define		GPIOSET_BAR_Y2			220

/////////////////////////////////////////////////////////////////////////////
// CAXCAC01App:
// See AXCAC01.cpp for the implementation of this class
//

#include "AxcACCtrl.h"

class CAXCAC01App : public CWinApp
{
public:
	CAXCAC01App();

	CAxcAcCtrl	m_AxcAcCtrl;
	INT			GetAxcPort()		{	return	m_nPort;	}
	INT			GetAxcCard()		{	return	m_nAxcCard;	}

	VOID		InitAxcCard();				// for PocketPC2003
	
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAXCAC01App)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CAXCAC01App)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	INT			m_nPort;
	INT			m_nAxcCard;

	DWORD		m_Battery;					//ޯذgp̓d
	DWORD		m_ExtPower;					//dgp̓d
	DWORD		m_NoUser;					//հްݒ薳̓d
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_AXCAC01_H__F26E2459_A7F1_4AFA_AF57_EDB8822F5D68__INCLUDED_)
