///////////////////////////////////////
//
//	CAxcAcCtrlNX	F
//
///////////////////////////////////////

#include "stdafx.h"
#include "AXCAC01.h"

#include "AxcAcCtrl.h"

///////////////////////////////////////
// CAxcAcCtrl NX

CAxcAcCtrl::CAxcAcCtrl()
{
	m_nADSampleEnd		= AD_SAMP_SINGLE;
	m_nADClockSrc		= AD_CLK_SRC2;
	m_nADClockBase		= AD_CLK_BASE_1;
	m_nADClockTime		= AD_SAMP_UM;
	m_nSamplingNumSet	= AD_DATA_1024;
	m_nADTrigger		= AD_TRG_NONE;

	m_nPortMode[0]		= 0;
	m_nPortMode[1]		= 0;
	m_nPortMode[2]		= 0;
	m_nPortMode[3]		= 0;
	
	m_nPort				= 0;
	m_bConnectionError	= FALSE;			//ڑG[
}

CAxcAcCtrl::~CAxcAcCtrl()
{
}

BOOL CAxcAcCtrl::Initialize(PINT pPortNo, PINT pAxcCard)
{
	INT			nAxcCard		= AXC_AC_CF;
	HMODULE		hDLL 			= NULL;
	FARPROC		pAxcac01GetPort	= NULL;
	LONG		lPort;
	CString		strPortName;
	BOOL		bRet;

	hDLL = (HMODULE)::LoadLibrary(TEXT("Axcac01.dll"));
	if (hDLL == NULL) 
	{
		AfxMessageBox(IDS_DLL_LOAD_ERROR);
		PostQuitMessage(0);
		return	FALSE;
	}

	pAxcac01GetPort = GetProcAddress(hDLL, _T("Axcac01FindComPort"));
	if(pAxcac01GetPort == NULL)
	{
		AfxMessageBox(IDS_DLL_LOAD_ERROR);
		PostQuitMessage(0);
		return	FALSE;
	}
	lPort	= (*pAxcac01GetPort)();

	::FreeLibrary(hDLL);

	strPortName.Format(TEXT("COM%ld:"),lPort);
	
	*pPortNo	= (INT)lPort;
	m_nPort		= (INT)lPort;

	bRet	= m_Com.MyOpenPort((LPTSTR)(LPCTSTR)strPortName);
	if(!bRet)
	{
		AfxMessageBox(IDS_OPEN_PORT_ERROR);
		PostQuitMessage(0);
		return	FALSE;
	}
	
	BYTE	byCmd[10];
	char	byData[40];
	CString	strMessage;
	
	sprintf((LPSTR)byCmd,"RS\r");
	if(!m_Com.MyWritePort(byCmd, 3))
	{
		m_Com.MyClosePort();
		CommandOutputError(TEXT("RS"));
		PostQuitMessage(0);
		return	FALSE;
	}
	
	sprintf((LPSTR)byCmd,"QU\r");
	if(!m_Com.MyWritePort(byCmd, 3))
	{
//		m_Com.MyClosePort();
		CommandOutputError(TEXT("QU"));
		return	FALSE;
	}
	if(!m_Com.MyReadPort((PBYTE)byData, sizeof(byData)))
	{
//		m_Com.MyClosePort();
		TimeoutError(TEXT("QU"));
		return	FALSE;
	}
	
	if(strstr(byData,"AXC-AC01") != NULL)
	{
		m_nAxcCard	= AXC_AC_CF;
		*pAxcCard	= m_nAxcCard;
	}
	else if(strstr(byData,"AXC-AD01") != NULL)
	{
		m_nAxcCard	= AXC_AD_CF;
		*pAxcCard	= m_nAxcCard;
	}
	else if(strstr(byData,"AXC-DA01") != NULL)
	{
		m_nAxcCard	= AXC_DA_CF;
		*pAxcCard	= m_nAxcCard;
	}
	else
	{
//		m_Com.MyClosePort();
		ResponseError(TEXT("QU"));
		return	FALSE;
	}

	sprintf((LPSTR)byCmd,"RM1\r");
	if(!m_Com.MyWritePort(byCmd, 4))
	{
//		m_Com.MyClosePort();
		CommandOutputError(TEXT("RM1"));
		return	FALSE;
	}
	if(!m_Com.MyReadPort((PBYTE)byData, AXC_RESPONSE_LENGTH))
	{
//		m_Com.MyClosePort();
		TimeoutError(TEXT("RM1"));
		return	FALSE;
	}
	if(byData[0] != 0 || byData[1] != 0)
	{
		ResponseError(TEXT("RM1"));
	}
	
	// |[g̏ݒ擾
#if 0
	sprintf((LPSTR)byCmd,"GA0\r");
	if(!m_Com.MyWritePort(byCmd, 4))
	{
		CommandOutputError(TEXT("GA0"));
		return	FALSE;
	}
	if(!m_Com.MyReadPort((PBYTE)byData, sizeof(byData)))
	{
		TimeoutError(TEXT("GA0"));
		return	FALSE;
	}
	if(byData[0] == 0 && byData[1] == 0)
		m_nPortMode[0]	= AXC_IO_IN;
	else
		ResponseError(TEXT("GA0"));

	sprintf((LPSTR)byCmd,"GB0\r");
	if(!m_Com.MyWritePort(byCmd, 4))
	{
		CommandOutputError(TEXT("GB0"));
		return	FALSE;
	}
	if(!m_Com.MyReadPort((PBYTE)byData, sizeof(byData)))
	{
		TimeoutError(TEXT("GB0"));
		return	FALSE;
	}
	if(byData[0] == 0 && byData[1] == 0)
		m_nPortMode[1]	= AXC_IO_IN;
	else
		ResponseError(TEXT("GB0"));

	sprintf((LPSTR)byCmd,"GC0\r");
	if(!m_Com.MyWritePort(byCmd, 4))
	{
		CommandOutputError(TEXT("GC0"));
		return	FALSE;
	}
	if(!m_Com.MyReadPort((PBYTE)byData, sizeof(byData)))
	{
		TimeoutError(TEXT("GC0"));
		return	FALSE;
	}
	if(byData[0] == 0 && byData[1] == 0)
		m_nPortMode[2]	= AXC_IO_IN;
	else
		ResponseError(TEXT("GC0"));

	sprintf((LPSTR)byCmd,"GD0\r");
	if(!m_Com.MyWritePort(byCmd, 4))
	{
		CommandOutputError(TEXT("GD0"));
		return	FALSE;
	}
	if(!m_Com.MyReadPort((PBYTE)byData, sizeof(byData)))
	{
		TimeoutError(TEXT("GD0"));
		return	FALSE;
	}
	if(byData[0] == 0 && byData[1] == 0)
		m_nPortMode[3]	= AXC_IO_IN;
	else
		ResponseError(TEXT("GD0"));

#endif

	return TRUE;
}

void CAxcAcCtrl::Terminate()
{
	m_Com.MyClosePort();
}

BOOL CAxcAcCtrl::SetADSampleEnd(INT nMode)
{
	if(m_nAxcCard == AXC_DA_CF)
		return	FALSE;

	char	cCmd[5];
	char	cRespons[20];

	if(nMode == AD_SAMP_SINGLE)
		sprintf(cCmd,"AD0\r");
	else if(nMode == AD_SAMP_DOUBLE)
		sprintf(cCmd,"AD1\r");
	else
		return	FALSE;

	if(!m_Com.MyWritePort((PBYTE)cCmd, 4))
	{
		CommandOutputError(TEXT("ADn"));
		return	FALSE;
	}

	if(!m_Com.MyReadPort((PBYTE)cRespons, AXC_RESPONSE_LENGTH))
	{
		TimeoutError(TEXT("ADn"));
		return	FALSE;
	}

	if(cRespons[0] == 0 && cRespons[1] == 0)
	{
		m_nADSampleEnd	= nMode;
		return	TRUE;
	}
	else
		ResponseError(TEXT("ADn"));

	return	FALSE;
}

BOOL CAxcAcCtrl::SetADClockSrc(INT nSrc)
{
	if(m_nAxcCard == AXC_DA_CF)
		return	FALSE;

	char	cCmd[5];
	char	cRespons[20];

	if(nSrc == AD_CLK_SRC1)
		sprintf(cCmd,"SC1\r");
	else if(nSrc == AD_CLK_SRC2)
		sprintf(cCmd,"SC2\r");
	else if(nSrc == AD_CLK_SRC3)
		sprintf(cCmd,"SC5\r");
	else
		return	FALSE;

	if(!m_Com.MyWritePort((PBYTE)cCmd, 4))
	{
		CommandOutputError(TEXT("SCn"));
		return	FALSE;
	}
	
	if(!m_Com.MyReadPort((PBYTE)cRespons, AXC_RESPONSE_LENGTH))
	{
		TimeoutError(TEXT("SCn"));
		return	FALSE;
	}

	if(cRespons[0] == 0 && cRespons[1] == 0)
	{
		m_nADClockSrc	= nSrc;
		return	TRUE;
	}
	else
		ResponseError(TEXT("SCn"));
	
	return	FALSE;
}

BOOL CAxcAcCtrl::SetADClockBase(INT nBase)
{
	if(m_nAxcCard == AXC_DA_CF)
		return	FALSE;

	char	cCmd[5];
	char	cRespons[20];

	if(nBase == AD_CLK_BASE_1)
		sprintf(cCmd,"SK0\r");
	else if(nBase == AD_CLK_BASE_10)
		sprintf(cCmd,"SK1\r");
	else if(nBase == AD_CLK_BASE_100)
		sprintf(cCmd,"SK2\r");
	else
		return	FALSE;

	if(!m_Com.MyWritePort((PBYTE)cCmd, 4))
	{
		CommandOutputError(TEXT("SKn"));
		return	FALSE;
	}
	
	if(!m_Com.MyReadPort((PBYTE)cRespons, AXC_RESPONSE_LENGTH))
	{
		TimeoutError(TEXT("SKn"));
		return	FALSE;
	}

	if(cRespons[0] == 0 && cRespons[1] == 0)
	{
		m_nADClockBase	= nBase;
		return	TRUE;
	}
	else
		ResponseError(TEXT("SKn"));

	return	FALSE;
}

BOOL CAxcAcCtrl::SetADClockTime(INT nTime)
{
	if(m_nAxcCard == AXC_DA_CF)
		return	FALSE;

	char	cCmd[5];
	char	cRespons[20];

	if(nTime == AD_SAMP_UM)
		sprintf(cCmd,"SU0\r");
	else if(nTime == AD_SAMP_MM)
		sprintf(cCmd,"SU1\r");
	else
		return	FALSE;

	if(!m_Com.MyWritePort((PBYTE)cCmd, 4))
	{
		CommandOutputError(TEXT("SUn"));
		return	FALSE;
	}
	
	if(!m_Com.MyReadPort((PBYTE)cRespons, AXC_RESPONSE_LENGTH))
	{
		TimeoutError(TEXT("SUn"));
		return	FALSE;
	}

	if(cRespons[0] == 0 && cRespons[1] == 0)
	{
		m_nADClockTime	= nTime;
		return	TRUE;
	}
	else
		ResponseError(TEXT("SUn"));
	
	return	FALSE;
}

BOOL CAxcAcCtrl::SetADSamplingNum(INT nNumSet)
{
	if(m_nAxcCard == AXC_DA_CF)
		return	FALSE;

	char	cCmd[5];
	char	cRespons[20];

	if(nNumSet == AD_DATA_1024)
		sprintf(cCmd,"ML0\r");
	else if(nNumSet == AD_DATA_2048)
		sprintf(cCmd,"ML1\r");
	else if(nNumSet == AD_DATA_4096)
		sprintf(cCmd,"ML2\r");
	else if(nNumSet == AD_DATA_8192)
		sprintf(cCmd,"ML3\r");
	else if(nNumSet == AD_DATA_16384_0)
		sprintf(cCmd,"ML4\r");
	else if(nNumSet == AD_DATA_16384_1)
		sprintf(cCmd,"ML5\r");
	else
		return	FALSE;

	if(!m_Com.MyWritePort((PBYTE)cCmd, 4))
	{
		CommandOutputError(TEXT("MLn"));
		return	FALSE;
	}
	
	if(!m_Com.MyReadPort((PBYTE)cRespons, AXC_RESPONSE_LENGTH))
	{
		TimeoutError(TEXT("MLn"));
		return	FALSE;
	}

	if(cRespons[0] == 0 && cRespons[1] == 0)
	{
		m_nSamplingNumSet	= nNumSet;
		return	TRUE;
	}
	else
		ResponseError(TEXT("MLn"));
	
	return	FALSE;
}

BOOL CAxcAcCtrl::SetADExtTrig(INT nTrig)
{
	if(m_nAxcCard == AXC_DA_CF)
		return	FALSE;

	char	cCmd[5];
	char	cRespons[20];

	if(nTrig == AD_TRG_NONE)
		sprintf(cCmd,"TS0\r");
	else if(nTrig == AD_TRG_EXT_U)
		sprintf(cCmd,"TS1\r");
	else if(nTrig == AD_TRG_EXT_D)
		sprintf(cCmd,"TS2\r");
	else if(nTrig == AD_TRG_CP_U)
		sprintf(cCmd,"TS3\r");
	else if(nTrig == AD_TRG_CP_D)
		sprintf(cCmd,"TS4\r");
	else if(nTrig == AD_TRG_PB_U)
		sprintf(cCmd,"TS5\r");
	else if(nTrig == AD_TRG_PB_D)
		sprintf(cCmd,"TS6\r");
	else
		return	FALSE;

	if(!m_Com.MyWritePort((PBYTE)cCmd, 4))
	{
		CommandOutputError(TEXT("TSn"));
		return	FALSE;
	}
	
	if(!m_Com.MyReadPort((PBYTE)cRespons, AXC_RESPONSE_LENGTH))
	{
		TimeoutError(TEXT("TSn"));
		return	FALSE;
	}

	if(cRespons[0] == 0 && cRespons[1] == 0)
	{
		m_nADTrigger	= nTrig;
		return	TRUE;
	}
	else
		ResponseError(TEXT("TSn"));

	return	FALSE;
}

BOOL CAxcAcCtrl::SetADTrgStart()
{
	if(m_nAxcCard == AXC_DA_CF)
		return	FALSE;

	char	cCmd[5];
	char	cRespons[20];
	TCHAR	szCmd[5];

	if(m_nADTrigger == AD_TRG_NONE)
	{
		sprintf(cCmd,"TG\r");
		wsprintf(szCmd,TEXT("TG"));
	}
	else
	{
		sprintf(cCmd,"TE\r");
		wsprintf(szCmd,TEXT("TE"));
	}
	
	if(!m_Com.MyWritePort((PBYTE)cCmd, 3))
	{
		CommandOutputError(szCmd);
		return	FALSE;
	}
	
	if(!m_Com.MyReadPort((PBYTE)cRespons, AXC_RESPONSE_LENGTH))
	{
		TimeoutError(szCmd);
		return	FALSE;
	}

	if(m_nADTrigger == AD_TRG_NONE)
	{
		if(cRespons[0] == 2 && cRespons[1] == 1)
			return	TRUE;	// DMA Start
		else
		{	// Error!
			ResponseError(szCmd);
		}
	}
	else
	{
		if(cRespons[0] == 1 && cRespons[1] == 2)
			return	TRUE;	// Waiting EXT Trig
		else
		{	// Error!
			ResponseError(szCmd);
		}
	}
	
	return	FALSE;
}

BOOL CAxcAcCtrl::SetADStop()
{
	if(m_nAxcCard == AXC_DA_CF)
		return	FALSE;

	char	cCmd[5];
	char	cRespons[20];

	sprintf(cCmd,"HL\r");

	if(!m_Com.MyWritePort((PBYTE)cCmd, 3))
	{
// 2005.02.14 ADD +++++++++++++++++++++++++++++ <S> +++
		{
			m_Com.MyCheckCOMState();
		}
// 2005.02.14 ADD +++++++++++++++++++++++++++++ <E> +++
		CommandOutputError(TEXT("HL"));

		return	FALSE;
	}
	
	if(!m_Com.MyReadPort((PBYTE)cRespons, AXC_RESPONSE_LENGTH))
	{
		TimeoutError(TEXT("HL"));
		return	FALSE;
	}

	if(cRespons[0] == 0 && cRespons[1] == 0)
		return	TRUE;
	else
	{	// Error!
		ResponseError(TEXT("HL"));
	}
	
	return	FALSE;
}

BOOL CAxcAcCtrl::GetADDmaResult(PBYTE pMode,PBYTE pCode)
{
	if(m_nAxcCard == AXC_DA_CF)
		return	FALSE;

	char	cRespons[10];

	if(!m_Com.MyReadPort((PBYTE)cRespons, AXC_RESPONSE_LENGTH))
	{
		return	FALSE;
	}

	*pMode	= cRespons[0];
	*pCode	= cRespons[1];

	return	TRUE;
}

BOOL CAxcAcCtrl::GetADDmaStatus(PBYTE pMode,PBYTE pCode)
{
	if(m_nAxcCard == AXC_DA_CF)
		return	FALSE;

	char	cCmd[5];
	char	cRespons[20];

	sprintf(cCmd,"QA\r");
	if(!m_Com.MyWritePort((PBYTE)cCmd, 3))
	{
		CommandOutputError(TEXT("QA"));
		return	FALSE;
	}
	
	if(!m_Com.MyReadPort((PBYTE)cRespons, AXC_RESPONSE_LENGTH))
	{
		TimeoutError(TEXT("QA"));
		return	FALSE;
	}

	*pMode	= cRespons[0];
	*pCode	= cRespons[1];

	return	TRUE;
}

BOOL CAxcAcCtrl::GetADData(INT nCh,double* pBuffer,WORD wBufSize)
{
	if(m_nAxcCard == AXC_DA_CF)
		return	FALSE;

	PBYTE	pbyBuffer;
	WORD	wSize	= 0;
	DWORD	dwBuffSize;
	
	switch(m_nSamplingNumSet)
	{
		case	AD_DATA_1024:		wSize	= 1024;		break;
		case	AD_DATA_2048:		wSize	= 2048;		break;
		case	AD_DATA_4096:		wSize	= 4096;		break;
		case	AD_DATA_8192:		wSize	= 8192;		break;
		case	AD_DATA_16384_0:	wSize	= 16384;	break;
		case	AD_DATA_16384_1:	wSize	= 16384;	break;
	
	}
	if(wSize == 0)
		return	FALSE;

	dwBuffSize	= (wSize * 2) + 3;
	pbyBuffer	= new BYTE[dwBuffSize];

	char	cCmd[5];

	if(nCh == 0)
		sprintf(cCmd,"BB0\r");
	else if(nCh == 1)
		sprintf(cCmd,"BB1\r");

	if(!m_Com.MyWritePort((PBYTE)cCmd, 4))
	{
		CommandOutputError(TEXT("BBn"));
		return	FALSE;
	}
	
	if(!m_Com.MyReadPort(pbyBuffer, dwBuffSize))
	{
		TimeoutError(TEXT("BBn"));
		return	FALSE;
	}

	if(nCh == 0)
	{
		if(pbyBuffer[0] != 0x20)
		{
			ResponseError(TEXT("BB0"));
			return	FALSE;
		}
	}
	else
	{
		if(pbyBuffer[0] != 0x21)
		{
			ResponseError(TEXT("BB1"));
			return	FALSE;
		}
	}

	WORD	n = (WORD)pbyBuffer[1] * 256 + (WORD)pbyBuffer[2];
	WORD	wData;
	double	dData;
	
	n	= (n - 3) / 2;
	if(wSize > wBufSize)
		n	= (int)wBufSize;

	WORD	j = 0;
	for(WORD i = 0; i < (n * 2); i += 2)
	{
		wData 			= (WORD)pbyBuffer[i+3] * 256 + (WORD)pbyBuffer[i+4];
		dData 			= AD_VAL_MAX * ((double)wData / (double)65535);
		pBuffer[j++]	= dData;
	}

	delete	pbyBuffer;
	
	return	TRUE;
}

BOOL CAxcAcCtrl::GetSingleData(double* pData1,double* pData2)
{
	if(m_nAxcCard == AXC_DA_CF)
		return	FALSE;

	char	cCmd[5];
	char	cRespons[20];

	sprintf(cCmd,"CB2\r");
	if(!m_Com.MyWritePort((PBYTE)cCmd, 4))
	{
		CommandOutputError(TEXT("CB2"));
		return	FALSE;
	}
	
	if(!m_Com.MyReadPort((PBYTE)cRespons, 5))
	{
		TimeoutError(TEXT("CB2"));
		return	FALSE;
	}

	if(cRespons[0] != 0x12)
	{
		ResponseError(TEXT("CB2"));
		return	FALSE;
	}

	WORD	wData1,wData2;
	double	dData1,dData2;

	wData1	= (WORD)((BYTE)cRespons[1] * 256) + (WORD)(BYTE)cRespons[2];
	wData2	= (WORD)((BYTE)cRespons[3] * 256) + (WORD)(BYTE)cRespons[4];

	dData1	= AD_VAL_MAX * ((double)wData1 / (double)65535);
	dData2	= AD_VAL_MAX * ((double)wData2 / (double)65535);

	*pData1	= dData1;
	*pData2	= dData2;

	return	TRUE;
}

// nCh = 0 or 1, wValue(12bit)
BOOL CAxcAcCtrl::SetDAValue(INT nCh,WORD wValue)
{
	if(m_nAxcCard == AXC_AD_CF)
		return	FALSE;

	char	cCmd[10];
	char	cRespons[20];

	sprintf(cCmd,"DB%d   \r",nCh);
	cCmd[4]	= (char)((wValue >> 8) & 0xff);
	cCmd[5]	= (char)(wValue & 0xff);
	if(!m_Com.MyWritePort((PBYTE)cCmd, 7))
	{
		CommandOutputError(TEXT("DB"));
		return	FALSE;
	}
	
	if(!m_Com.MyReadPort((PBYTE)cRespons, AXC_RESPONSE_LENGTH))
	{
		TimeoutError(TEXT("DB"));
		return	FALSE;
	}

	if(cRespons[0] == 0 && cRespons[1] == 0)
		return	TRUE;
	else
	{	// Error!
		ResponseError(TEXT("DB"));
	}
	
	return	FALSE;
}

// nLevel = 0:LOW(0),1:HIGH(1)
BOOL CAxcAcCtrl::SetPortData(INT nPort,INT nLevel)
{
	char	cCmd[10];
	char	cRespons[20];
	TCHAR	szCmd[5];

	switch(nPort)
	{
		case	AXC_PORTA:
			{
				if(m_nPortMode[0] == AXC_IO_IN || m_nPortMode[0] == AXC_IO_IN_AD)
					return	FALSE;

				if(nLevel == 0)
				{
					sprintf(cCmd,"PA0\r");
					wsprintf(szCmd,TEXT("PA0"));
				}
				else
				{
					sprintf(cCmd,"PA1\r");
					wsprintf(szCmd,TEXT("PA1"));
				}
			}
			break;
		case	AXC_PORTB:
			{
				if(m_nPortMode[1] == AXC_IO_IN)
					return	FALSE;

				if(nLevel == 0)
				{
					sprintf(cCmd,"PB0\r");
					wsprintf(szCmd,TEXT("PB0"));
				}
				else
				{
					sprintf(cCmd,"PB1\r");
					wsprintf(szCmd,TEXT("PB1"));
				}
			}
			break;
		case	AXC_PORTC:
			{
				if(m_nPortMode[2] == AXC_IO_IN)
					return	FALSE;

				if(nLevel == 0)
				{
					sprintf(cCmd,"PC0\r");
					wsprintf(szCmd,TEXT("PC0"));
				}
				else
				{
					sprintf(cCmd,"PC1\r");
					wsprintf(szCmd,TEXT("PC1"));
				}
			}
			break;
		case	AXC_PORTD:
			{
				if(m_nPortMode[3] == AXC_IO_IN)
					return	FALSE;

				if(nLevel == 0)
				{
					sprintf(cCmd,"PD0\r");
					wsprintf(szCmd,TEXT("PD0"));
				}
				else
				{
					sprintf(cCmd,"PD1\r");
					wsprintf(szCmd,TEXT("PD1"));
				}
			}
			break;
		default:
			return	FALSE;
	}

	if(!m_Com.MyWritePort((PBYTE)cCmd, 4))
	{
		CommandOutputError(szCmd);
		return	FALSE;
	}
	
	if(!m_Com.MyReadPort((PBYTE)cRespons, AXC_RESPONSE_LENGTH))
	{
		TimeoutError(szCmd);
		return	FALSE;
	}
	if(cRespons[0] == 0 && cRespons[1] == 0)
		return	TRUE;
	else
	{	// Error!
		ResponseError(szCmd);
	}
	
	return	FALSE;
}
		
BOOL CAxcAcCtrl::GetPortAAData(double* pData)
{
	if(m_nPortMode[0] != AXC_IO_IN_AD)
	{
		return	FALSE;
	}
	
	char	cCmd[5];
	char	cRespons[20];

	sprintf((LPSTR)cCmd,"CB3\r");
	if(!m_Com.MyWritePort((PBYTE)cCmd, 4))
	{
		CommandOutputError(TEXT("CB3"));
		return	FALSE;
	}
	
	if(!m_Com.MyReadPort((PBYTE)cRespons, 3))
	{
		TimeoutError(TEXT("CB3"));
		return	FALSE;
	}

	if(cRespons[0] != 0x13)
	{
		ResponseError(TEXT("CB3"));
		return	FALSE;
	}
	
	WORD	wData1;
	double	dData1;

	wData1	= (WORD)((BYTE)cRespons[1] * 256) + (WORD)(BYTE)cRespons[2];

	dData1	= AD_VAL_MAX_PA * ((double)wData1 / (double)0x3ff);

	*pData	= dData1;

	return	TRUE;
}

// pData = 0 or 1
BOOL CAxcAcCtrl::GetPortData(INT nPort,PBYTE pData)
{
	char	cCmd[10];
	char	cRespons[20];
	TCHAR	szCmd[5];

	switch(nPort)
	{
		case	AXC_PORTA:
			{
				if(m_nPortMode[0] == AXC_IO_IN)
				{
					sprintf(cCmd,"QP0\r");
					wsprintf(szCmd,TEXT("QP0"));
				}
				else
					return	FALSE;
			}
			break;
		case	AXC_PORTB:
			{
				if(m_nPortMode[1] == AXC_IO_IN)
				{
					sprintf(cCmd,"QP1\r");
					wsprintf(szCmd,TEXT("QP1"));
				}
				else
					return	FALSE;
			}
			break;
		case	AXC_PORTC:
			{
				if(m_nPortMode[2] == AXC_IO_IN)
				{
					sprintf(cCmd,"QP2\r");
					wsprintf(szCmd,TEXT("QP2"));
				}
				else
					return	FALSE;
			}
			break;
		case	AXC_PORTD:
			{
				if(m_nPortMode[3] == AXC_IO_IN)
				{
					sprintf(cCmd,"QP3\r");
					wsprintf(szCmd,TEXT("QP3"));
				}
				else
					return	FALSE;
			}
			break;
		default:
			return	FALSE;
	}

	if(!m_Com.MyWritePort((PBYTE)cCmd, 4))
	{
		CommandOutputError(szCmd);
		return	FALSE;
	}
	
	if(!m_Com.MyReadPort((PBYTE)cRespons, 1))
	{
		TimeoutError(szCmd);
		return	FALSE;
	}

	*pData	= (BYTE)cRespons[0];

	return	TRUE;
}

BOOL CAxcAcCtrl::SetPortMode(INT nPort,INT nMode)
{
	char	cCmd[10];
	char	cRespons[20];
	PINT	pPortMode;
	TCHAR	szCmd[5];

	switch(nPort)
	{
		case	AXC_PORTA:
			{
				if(nMode == AXC_IO_IN)
				{
					sprintf(cCmd,"GA0\r");
					wsprintf(szCmd,TEXT("GA0"));
				}
				else if(nMode == AXC_IO_OUT_O)
				{
					sprintf(cCmd,"GA1\r");
					wsprintf(szCmd,TEXT("GA1"));
				}
				else if(nMode == AXC_IO_OUT_P)
				{
					sprintf(cCmd,"GA2\r");
					wsprintf(szCmd,TEXT("GA2"));
				}
				else if(nMode == AXC_IO_IN_AD)
				{
					sprintf(cCmd,"GA3\r");
					wsprintf(szCmd,TEXT("GA3"));
				}
				else
					return	FALSE;
				
				pPortMode	= &m_nPortMode[0];
			}
			break;
		case	AXC_PORTB:
			{
				if(nMode == AXC_IO_IN)
				{
					sprintf(cCmd,"GB0\r");
					wsprintf(szCmd,TEXT("GB0"));
				}
				else if(nMode == AXC_IO_OUT_O)
				{
					sprintf(cCmd,"GB1\r");
					wsprintf(szCmd,TEXT("GB1"));
				}
				else if(nMode == AXC_IO_OUT_P)
				{
					sprintf(cCmd,"GB2\r");
					wsprintf(szCmd,TEXT("GB2"));
				}
				else
					return	FALSE;
				
				pPortMode	= &m_nPortMode[1];
			}
			break;
		case	AXC_PORTC:
			{
				if(nMode == AXC_IO_IN)
				{
					sprintf(cCmd,"GC0\r");
					wsprintf(szCmd,TEXT("GC0"));
				}
				else if(nMode == AXC_IO_OUT_O)
				{
					sprintf(cCmd,"GC1\r");
					wsprintf(szCmd,TEXT("GC1"));
				}
				else if(nMode == AXC_IO_OUT_P)
				{
					sprintf(cCmd,"GC2\r");
					wsprintf(szCmd,TEXT("GC2"));
				}
				else
					return	FALSE;
				
				pPortMode	= &m_nPortMode[2];
			}
			break;
		case	AXC_PORTD:
			{
				if(nMode == AXC_IO_IN)
				{
					sprintf(cCmd,"GD0\r");
					wsprintf(szCmd,TEXT("GD0"));
				}
				else if(nMode == AXC_IO_OUT_O)
				{
					sprintf(cCmd,"GD1\r");
					wsprintf(szCmd,TEXT("GD1"));
				}
				else if(nMode == AXC_IO_OUT_P)
				{
					sprintf(cCmd,"GD2\r");
					wsprintf(szCmd,TEXT("GD2"));
				}
				else
					return	FALSE;
				
				pPortMode	= &m_nPortMode[3];
			}
			break;
		default:
			return	FALSE;
	}
	
	if(!m_Com.MyWritePort((PBYTE)cCmd, 4))
	{
		CommandOutputError(szCmd);
		return	FALSE;
	}
	
	if(!m_Com.MyReadPort((PBYTE)cRespons, AXC_RESPONSE_LENGTH))
	{
		TimeoutError(szCmd);
		return	FALSE;
	}
	
	if(cRespons[0] == 0 && cRespons[1] == 0)
	{
		*pPortMode	= nMode;
		return	TRUE;
	}
	else
		ResponseError(szCmd);

	return	FALSE;
}

VOID CAxcAcCtrl::CommandOutputError(LPTSTR pCmd)
{
	CString	strMessage;

// 2007.07.09:for Mobile5.0 -->
	if(!CheckConnection())
		return;
// <-- 2007.07.09

	strMessage.LoadString(IDS_OUTPUT_ERROR);
	strMessage += pCmd;				// 2005.02.14:ADD
//	strMessage += TEXT("RS");		// 2005.02.14:ADD
	AfxMessageBox(strMessage);
}

// 2007.07.09:for Mobile5.0 -->
BOOL CAxcAcCtrl::CheckConnection(void)
{
	BOOL	bRtc	= TRUE;
	BYTE	byCmd[10];
	char	byData[40];
	CString	strMessage;

	if(m_bConnectionError == TRUE)			//ڑG[
		return	FALSE;

	if(m_nPort == 0)
		return	FALSE;

	sprintf((LPSTR)byCmd,"QU\r");
	if(!m_Com.MyWritePort(byCmd, 3))
	{
		bRtc	= FALSE;
	}
	if(!m_Com.MyReadPort((PBYTE)byData, sizeof(byData)) && bRtc)
	{
		bRtc	= FALSE;
	}
	
	if(bRtc)
	{
		if(strstr(byData,"AXC-AC01") != NULL)
		{
			if(m_nAxcCard != AXC_AC_CF)
			{
				bRtc	= FALSE;
			}
		}
		else if(strstr(byData,"AXC-AD01") != NULL)
		{
			if(m_nAxcCard != AXC_AD_CF)
			{
				bRtc	= FALSE;
			}
		}
		else if(strstr(byData,"AXC-DA01") != NULL)
		{
			if(m_nAxcCard != AXC_DA_CF)
			{
				bRtc	= FALSE;
			}
		}
		else
		{
			bRtc	= FALSE;
		}
	}
	
	if(!bRtc)
	{
		bRtc	= FALSE;
		m_Com.MyClosePort();
		m_bConnectionError	= TRUE;			//ڑG[

		CString	strMessage;

		strMessage.LoadString(IDS_CONNECTION_ERROR);
		AfxMessageBox(strMessage);
		::PostQuitMessage(0);

		return	FALSE;
	}
	return	TRUE;
}
// <-- 2007.07.09

VOID CAxcAcCtrl::ResponseError(LPTSTR pCmd)
{
	CString	strTemp;
	CString	strMessage;

	strTemp.LoadString(IDS_RESPONSE_ERROR);
	strMessage.Format(strTemp, pCmd);
	AfxMessageBox(strMessage);
}

VOID CAxcAcCtrl::TimeoutError(LPTSTR pCmd)
{
	CString	strTemp;
	CString	strMessage;

	strTemp.LoadString(IDS_TIMEOUT_ERROR);
	strMessage.Format(strTemp, pCmd);
	AfxMessageBox(strMessage);
}

