///////////////////////////////////////
//
//	CComuNX	F@VAʐMNX
//
///////////////////////////////////////

#include "stdafx.h"
#include "AXCAC01.h"

#include "comu.h"

///////////////////////////////////////
// CComu NX

CComu::CComu()
{
	m_hComm = NULL;											//ٸر
}

CComu::~CComu()
{
}

BOOL CComu::MyOpenPort(LPTSTR lpszPortName)
{
	DCB				PortDCB;

// 2005.02.14 ADD +++++++++++++++++++++++++++++ <S> +++
	_tcscpy(m_szFileName,lpszPortName);
// 2005.02.14 ADD +++++++++++++++++++++++++++++ <E> +++

  // Open the serial port.
	m_hComm = CreateFile (lpszPortName, 	// Pointer to the name of the port
	                      GENERIC_READ | GENERIC_WRITE,   // Access (read-write) mode
	                      0,            	// Share mode
	                      NULL,         	// Pointer to the security attribute
	                      OPEN_EXISTING,	//OPEN_ALWAYS,// How to open the serial port
	                      FILE_FLAG_OVERLAPPED, //FILE_ATTRIBUTE_NORMAL,	//0,            // Port attributes
	                      NULL);        	// Handle to port with attribute
	                                    	// to copy

  // If it fails to open the port, return FALSE.
	if ( m_hComm == INVALID_HANDLE_VALUE ) 
		return FALSE;

	PortDCB.DCBlength = sizeof(DCB);     

  // Get the default port setting information.
	if(!GetCommState (m_hComm, &PortDCB))
		return FALSE;

  // Change the DCB structure settings.
	PortDCB.BaudRate		= CBR_115200;			// Current baud 
	PortDCB.fBinary			= TRUE;					// Binary mode; no EOF check 
	PortDCB.fParity			= TRUE;					// Enable parity checking 
	PortDCB.fOutxCtsFlow	= TRUE;					// No CTS output flow control 
	PortDCB.fOutxDsrFlow	= TRUE;					// No DSR output flow control 
  	PortDCB.fDtrControl		= DTR_CONTROL_ENABLE;	// DTR flow control type 
	PortDCB.fDsrSensitivity = TRUE;					// DSR sensitivity 
//	PortDCB.fDsrSensitivity = FALSE;				// DSR sensitivity 
	PortDCB.fTXContinueOnXoff = FALSE;				// XOFF continues Tx 
	PortDCB.fOutX			= FALSE;				// No XON/XOFF out flow control 
	PortDCB.fInX			= FALSE;				// No XON/XOFF in flow control 
	PortDCB.fErrorChar		= TRUE;					// Disable error replacement 
//	PortDCB.fErrorChar		= FALSE;				// Disable error replacement 
	PortDCB.fNull			= FALSE;				// Disable null stripping 
	PortDCB.fRtsControl		= RTS_CONTROL_ENABLE;	// RTS flow control 
	PortDCB.fAbortOnError	= FALSE;				// Do not abort reads/writes on error
	PortDCB.ByteSize		= 8;					// Number of bits/byte, 4-8 
	PortDCB.Parity			= NOPARITY;				// 0-4=no,odd,even,mark,space 
	PortDCB.StopBits		= ONESTOPBIT;		    // 0,1,2 = 1, 1.5, 2 

  // Configure the port according to the specifications of the DCB 
  // structure.
	DWORD dwError;
	if (!::SetCommState (m_hComm, &PortDCB))
	{
		dwError = GetLastError();
		return FALSE;
	}
  // Retrieve the time-out parameters for all read and write operations
  // on the port. 
	COMMTIMEOUTS	cto;
	::GetCommTimeouts(m_hComm, &cto);
	cto.WriteTotalTimeoutConstant 	= WRITE_TOTAL_TIMEOUT;
	cto.WriteTotalTimeoutMultiplier	= 0;						//2004/09/07
	cto.ReadTotalTimeoutConstant  	= READ_TOTAL_TIMEOUT;
//	cto.ReadIntervalTimeout       	= READ_INTERVAL_TIMEOUT;
//	cto.ReadTotalTimeoutMultiplier	= READ_TOTAL_TIMEOUT;
	cto.ReadIntervalTimeout       	= 0;						//2004/09/07
	cto.ReadTotalTimeoutMultiplier	= 0;						//2004/09/07
	::SetCommTimeouts(m_hComm, &cto);

	return TRUE;
}

void CComu::MyClosePort()
{
	if(m_hComm == INVALID_HANDLE_VALUE || m_hComm == NULL) 		//߰Ă݂ĂȂꍇ͏Ȃ
		return;

	if (m_hComm){
		CloseHandle(m_hComm);									//߰ĸ۰
		m_hComm = NULL;
	}
}

BOOL CComu::MyWritePort(LPBYTE lpData, DWORD dwLen)
{
	DWORD	dwWritten;

	BOOL	bRet = WriteFile(m_hComm, lpData, dwLen, &dwWritten, NULL);	//ްM

	if (bRet && (dwLen != dwWritten))									//MsorMްs̏ꍇ
	{
		bRet = FALSE;
	}
// 2005.02.14 ADD +++++++++++++++++++++++++++++ <S> +++
//	if(!bRet)
//	{
//		AfxMessageBox(TEXT("WritePort Error"));
//		if(MyCheckCOMState())
//		{
//			AfxMessageBox(TEXT("ReOpen OK"));
//
//			char	cCmd[5];
//	
//			sprintf(cCmd,"RS\r");
//			bRet = WriteFile(m_hComm, cCmd, 3, &dwWritten, NULL);	//ްM
//			if(bRet && (dwWritten != 3))							//MsorMްs̏ꍇ
//				bRet = FALSE;
//			else
//				AfxMessageBox(TEXT("Reset OK"));
//
//			bRet = WriteFile(m_hComm, lpData, dwLen, &dwWritten, NULL);	//ްM
//			if(bRet && (dwLen != dwWritten))							//MsorMްs̏ꍇ
//				bRet = FALSE;
//			else
//				AfxMessageBox(TEXT("Re WritePort OK"));
//		}
//		else
//			AfxMessageBox(TEXT("ReOpen Fail"));
//	}
// 2005.02.14 ADD +++++++++++++++++++++++++++++ <E> +++

	return	bRet;
}

DWORD CComu::MyReadPort(LPBYTE lpData, DWORD dwLen)
{
	DWORD	dwRead = 0;

	BOOL	bRet = ReadFile(m_hComm, lpData, dwLen, &dwRead, NULL);	//ްM

	return	dwRead;													//Mςް
}

// 2005.02.14 ADD +++++++++++++++++++++++++++++ <S> +++
// Mf[^ƃG[̃`FbN֐
DWORD CComu::MyGetReceiveDataNum(LPDWORD pError)
{
	COMSTAT	ComStat;

	::ClearCommError(m_hComm,pError,&ComStat); 		// error:E_OVERRUN=1

	return ComStat.cbInQue;
}


BOOL CComu::MyCheckCOMState(void)
{
	COMSTAT	ComStat;
	CString	strTest;
	DWORD	dwError;

	::ClearCommError(m_hComm,&dwError,&ComStat); 		// error:E_OVERRUN=1
//	if(ComStat.fCtsHold == 1)
	{
		strTest.Format(	TEXT("(1)CTS=%ld,DSR=%ld,RLSD=%ld,XOFF_H=%ld,XOFF_S=%ld,EOF=%ld,TXIM=%ld,INQUE=%ld,OUTQUE=%ld"),
						ComStat.fCtsHold,ComStat.fDsrHold,ComStat.fRlsdHold,ComStat.fXoffHold,
						ComStat.fXoffSent,ComStat.fEof,ComStat.fTxim,ComStat.cbInQue,ComStat.cbOutQue);
		AfxMessageBox(strTest);

		::EscapeCommFunction(m_hComm, CLRRTS);
		::Sleep(500);
		::EscapeCommFunction(m_hComm, SETRTS);
//		MyClosePort();

		// Open the serial port.
//		if(!MyOpenPort(m_szFileName)) 
//		{
//			AfxMessageBox(TEXT("COM Port Fail."));
//			return	FALSE;
//		}
		::ClearCommError(m_hComm,&dwError,&ComStat); 		// error:E_OVERRUN=1
		strTest.Format(	TEXT("(2)CTS=%ld,DSR=%ld,RLSD=%ld,XOFF_H=%ld,XOFF_S=%ld,EOF=%ld,TXIM=%ld,INQUE=%ld,OUTQUE=%ld"),
						ComStat.fCtsHold,ComStat.fDsrHold,ComStat.fRlsdHold,ComStat.fXoffHold,
						ComStat.fXoffSent,ComStat.fEof,ComStat.fTxim,ComStat.cbInQue,ComStat.cbOutQue);
		AfxMessageBox(strTest);
	}
	if(ComStat.fCtsHold == 0)
		return	TRUE;

	return	FALSE;
}
// 2005.02.14 ADD +++++++++++++++++++++++++++++ <E> +++
 
